/*** CheckResponse.cpp ***/
// Copyright (C) 2009 by Torsten Knorr
// All rights reserved!
// create-soft@freenet.de
//-----------------------------------------------
 #include "stdafx.h"
 #include "RelayCard.h"
//-----------------------------------------------
 BOOL CheckResponse(PVOID pvoid)
	{
	volatile PPARAMS_WRITE pparams;
	pparams = (PPARAMS_WRITE)pvoid;
#ifdef _DEBUG
	TCHAR sz_buffer[256];
	wsprintf(
		sz_buffer,
		TEXT("frame write:\t%u\t%u\t%u\t%u\n")
		TEXT("frame read:\t%u\t%u\t%u\t%u"),
		pparams->frame_write.command,
		pparams->frame_write.address,
		pparams->frame_write.data,
		pparams->frame_write.checksum,
		pparams->frame_read.command,
		pparams->frame_read.address,
		pparams->frame_read.data,
		pparams->frame_read.checksum
		);
	MessageBox(NULL, sz_buffer, TEXT("CheckResponse"), MB_OK);
#endif
	if(!
		pparams->frame_read.checksum
		==
		(pparams->frame_read.command ^ pparams->frame_read.address ^ pparams->frame_read.data)
		)
		return MyErrorMessage(TEXT("CheckResponse : Checksumerror"));
	switch(pparams->frame_write.command)
		{
		case NO_OPERATION:
			if(!(
				(NO_OPERATION_OK == pparams->frame_read.command)
				||
				((NO_OPERATION == pparams->frame_read.command) && (0 == pparams->frame_write.address))
				))
				return MyErrorMessage(TEXT("CheckResponse : ERROR - NO_OPERATION"));
			break;
		case SETUP:
			if(!(
				(SETUP_OK == pparams->frame_read.command)
				||
				(SETUP == pparams->frame_read.command)
				))
				return MyErrorMessage(TEXT("CheckResponse : ERROR - SETUP"));
			pparams->cards_count = pparams->frame_read.address - 1;
			break;
		case GET_PORT:
			if(GET_PORT_OK != pparams->frame_read.command)
				return MyErrorMessage(TEXT("CheckResponse : ERROR - GET_PORT"));
			break;
		case SET_PORT:
			if(!(
				(SET_PORT_OK == pparams->frame_read.command)
				||
				(((SET_PORT == pparams->frame_read.command)
				||
				(NO_OPERATION == pparams->frame_read.command)) 
				&&
				(0 == pparams->frame_write.address))
				))
				return MyErrorMessage(TEXT("CheckResponse : ERROR - SET_PORT"));
			break;
		case GET_OPTION:
			if(GET_OPTION_OK != pparams->frame_read.command)
				return MyErrorMessage(TEXT("CheckResponse : ERROR - GET_OPTION"));
			break;
		case SET_OPTION:
			if(!(
				(SET_OPTION_OK == pparams->frame_read.command)
				||
				((SET_OPTION == pparams->frame_read.command) && (0 == pparams->frame_write.address))
				))
				return MyErrorMessage(TEXT("CheckResponse : ERROR - SET_OPTION"));
			break;
	case SET_SINGLE:
			if(!(
				(SET_SINGLE_OK == pparams->frame_read.command)
				|| 
				((SET_SINGLE == pparams->frame_read.command) && (0 == pparams->frame_write.address))
				))
				return MyErrorMessage(TEXT("CheckResponse : ERROR - SET_SINGLE"));
			break;
		case DEL_SINGLE:
			if(!(
				(DEL_SINGLE_OK == pparams->frame_read.command)
				||
				((DEL_SINGLE == pparams->frame_read.command) && (0 == pparams->frame_write.address))
				))
				return MyErrorMessage(TEXT("CheckResponse : ERROR - DEL_SINGLE"));
			break;
		case TOGGLE:
			if(!(
				(TOGGLE_OK == pparams->frame_read.command)
				||
				(((TOGGLE == pparams->frame_read.command)
				||
				(NO_OPERATION == pparams->frame_read.command))
				&&
				(0 == pparams->frame_write.address))
				))
				return MyErrorMessage(TEXT("CheckResponse : ERROR - TOGGLE"));
			break;
		default:
			return MyErrorMessage(TEXT("CSerialComm:CheckResponse : ERROR - undefined command"));
			break;  
		}
	return TRUE;
	}
//-----------------------------------------------