/*** ThreadWrite.cpp ***/
// Copyright (C) 2009 by Torsten Knorr
// All rights reserved!
// create-soft@freenet.de
//-----------------------------------------------
 #include "stdafx.h"
 #include "RelayCard.h"
//-----------------------------------------------
 extern HANDLE g_handle_event_write;
 extern HANDLE g_handle_event_ready;
//-----------------------------------------------
 VOID ThreadWrite(PVOID pvoid)
	{
	volatile PPARAMS_WRITE pparams;
	pparams = (PPARAMS_WRITE)pvoid;
	DWORD dw_written = 0;
	while(pparams->b_thread_running)
		{
		SetEvent(g_handle_event_ready);
		switch(WaitForSingleObject(g_handle_event_write, pparams->write_timeout))
			{
// If the function fails, the return value is WAIT_FAILED.
//To get extended error information, call GetLastError.
			case WAIT_FAILED:
				MyErrorMessage(TEXT("ThreadWrite : WaitForSingleObject : WAIT_FAILED"));
				break;
//The specified object is a mutex object that was not released by the thread that owned the mutex object 
// before the owning thread terminated. Ownership of the mutex object is granted to the calling thread, 
// and the mutex is set to nonsignaled.
			case WAIT_ABANDONED:
				break; 
// The state of the specified object is signaled. 
			case WAIT_OBJECT_0:
// Issue write
				if(!WriteFile(pparams->handle_port, &pparams->frame_write, 4, &dw_written, NULL))
					MyErrorMessage(TEXT("ThreadWrite : WriteFile"));
				else
					{
// Write operation completed successfully.
// Is it a successfully write?
					if(4 != dw_written)
						MyErrorMessage(TEXT("ThreadWrite : 4 != dw_written"));
					if(!Read(pparams))
						MyErrorMessage(TEXT("ThreadWrite : Read"));
					}
				break; 
// The time-out interval elapsed, and the object's state is nonsignaled.
			case WAIT_TIMEOUT:
				// MyErrorMessage(TEXT("ThreadWrite : WaitForSingleObject : WAIT_TIMEOUT"));
				break;
			default:
				MyErrorMessage(TEXT("ThreadWrite : WaitForSingleObject : unknown error"));
				break; 
			}
		}
	_endthread();
	}
//-----------------------------------------------